3 __scriptpath=$(cd "$(dirname "$0")"; pwd -P)
4 __init_tools_log="$__scriptpath/init-tools.log"
5 __PACKAGES_DIR="$__scriptpath/packages"
6 __TOOLRUNTIME_DIR="$__scriptpath/Tools"
7 __DOTNET_PATH="$__TOOLRUNTIME_DIR/dotnetcli"
8 __DOTNET_CMD="$__DOTNET_PATH/dotnet"
9 if [ -z "${__BUILDTOOLS_SOURCE:-}" ]; then __BUILDTOOLS_SOURCE=https://dotnet.myget.org/F/dotnet-buildtools/api/v3/index.json; fi
10 export __BUILDTOOLS_USE_CSPROJ=true
11 __BUILD_TOOLS_PACKAGE_VERSION=$(cat "$__scriptpath/BuildToolsVersion.txt" | sed 's/\r$//') # remove CR if mounted repo on Windows drive
12 __DOTNET_TOOLS_VERSION=$(cat "$__scriptpath/DotnetCLIVersion.txt" | sed 's/\r$//') # remove CR if mounted repo on Windows drive
13 __ILASM_VERSION=$(cat "$__scriptpath/ILAsmVersion.txt" | sed 's/\r$//') # remove CR if mounted repo on Windows drive
14 __BUILD_TOOLS_PATH="$__PACKAGES_DIR/microsoft.dotnet.buildtools/$__BUILD_TOOLS_PACKAGE_VERSION/lib"
15 __INIT_TOOLS_RESTORE_PROJECT="$__scriptpath/init-tools.msbuild"
16 __BUILD_TOOLS_SEMAPHORE="$__TOOLRUNTIME_DIR/$__BUILD_TOOLS_PACKAGE_VERSION/init-tools.complete"
18 if [ -e "$__BUILD_TOOLS_SEMAPHORE" ]; then
19 echo "Tools are already initialized"
20 return #return instead of exit because this script is inlined in other scripts which we don't want to exit
23 if [ -e "$__TOOLRUNTIME_DIR" ]; then rm -rf -- "$__TOOLRUNTIME_DIR"; fi
25 if [ -d "${DotNetBuildToolsDir:-}" ]; then
26 echo "Using tools from '$DotNetBuildToolsDir'."
27 ln -s "$DotNetBuildToolsDir" "$__TOOLRUNTIME_DIR"
29 if [ ! -e "$__DOTNET_CMD" ]; then
30 echo "ERROR: Ensure that $DotNetBuildToolsDir contains the .NET Core SDK at $__DOTNET_PATH"
34 echo "Done initializing tools."
35 mkdir -p "$(dirname "$__BUILD_TOOLS_SEMAPHORE")" && touch "$__BUILD_TOOLS_SEMAPHORE"
36 return #return instead of exit because this script is inlined in other scripts which we don't want to exit
39 echo "Running: $__scriptpath/init-tools.sh" > "$__init_tools_log"
41 display_error_message()
43 echo "Please check the detailed log that follows." 1>&2
44 cat "$__init_tools_log" 1>&2
47 # Executes a command and retries if it fails.
48 execute_with_retry() {
50 local retries=${retries:-5}
51 local waitFactor=${waitFactor:-6}
54 count=$(( $count + 1 ))
55 if [ $count -lt $retries ]; then
56 local wait=$(( waitFactor ** (( count - 1 )) ))
57 echo "Retry $count/$retries exited $exit, retrying in $wait seconds..."
60 say_err "Retry $count/$retries exited $exit, no more retries left."
68 if [ ! -e "$__DOTNET_PATH" ]; then
69 if [ -z "${__DOTNET_PKG:-}" ]; then
70 if [ "$(uname -m | grep "i[3456]86")" = "i686" ]; then
71 echo "Warning: build not supported on 32 bit Unix"
74 if [ "$(uname -m)" = "armhf" ] || [ "$(uname -m)" = "arm64" ] || [ "$(uname -m)" = "aarch64" ]; then
75 if [ "$(uname -m)" = "armhf" ]; then
79 if [ "$(uname -m)" = "arm64" ] || [ "$(uname -m)" = "aarch64" ]; then
92 # Format x.y.z as single integer with three digits for each part
93 VERSION=`sw_vers -productVersion| sed -e 's/\./ /g' | xargs printf "%03d%03d%03d"`
94 if [ "$VERSION" -lt 010012000 ]; then
95 echo error: macOS version `sw_vers -productVersion` is too old. 10.12 is needed as minimum.
107 if [ -e /etc/os-release ]; then
108 source /etc/os-release
109 if [[ $ID == "alpine" ]]; then
112 elif [ -e /etc/redhat-release ]; then
113 redhatRelease=$(</etc/redhat-release)
114 if [[ $redhatRelease == "CentOS release 6."* || $redhatRelease == "Red Hat Enterprise Linux Server release 6."* ]]; then
119 if [ $OSArch == 'armv7l' ];then
121 elif [ $OSArch == 'aarch64' ]; then
128 echo "Unsupported OS '$OSName' detected. Downloading linux-$__PKG_ARCH tools."
133 __PKG_RID=$__PKG_RID-$__PKG_ARCH
134 __DOTNET_PKG=dotnet-sdk-${__DOTNET_TOOLS_VERSION}-$__PKG_RID
136 mkdir -p "$__DOTNET_PATH"
138 echo "Installing dotnet cli..."
139 __DOTNET_LOCATION="https://dotnetcli.azureedge.net/dotnet/Sdk/${__DOTNET_TOOLS_VERSION}/${__DOTNET_PKG}.tar.gz"
141 install_dotnet_cli() {
142 if [[ -z "${DotNetBootstrapCliTarPath-}" ]]; then
143 echo "Installing '${__DOTNET_LOCATION}' to '$__DOTNET_PATH/dotnet.tar'"
144 rm -rf -- "$__DOTNET_PATH/*"
145 # curl has HTTPS CA trust-issues less often than wget, so lets try that first.
146 if command -v curl > /dev/null; then
147 curl --retry 10 -sSL --create-dirs -o $__DOTNET_PATH/dotnet.tar ${__DOTNET_LOCATION}
149 wget -q -O $__DOTNET_PATH/dotnet.tar ${__DOTNET_LOCATION}
152 echo "Copying '$DotNetBootstrapCliTarPath' to '$__DOTNET_PATH/dotnet.tar'"
153 cp $DotNetBootstrapCliTarPath $__DOTNET_PATH/dotnet.tar
156 tar -xf "$__DOTNET_PATH/dotnet.tar"
158 execute_with_retry install_dotnet_cli >> "$__init_tools_log" 2>&1
163 if [ ! -e "$__BUILD_TOOLS_PATH" ]; then
164 echo "Restoring BuildTools version $__BUILD_TOOLS_PACKAGE_VERSION..."
165 echo "Running: $__DOTNET_CMD restore \"$__INIT_TOOLS_RESTORE_PROJECT\" --no-cache --packages $__PACKAGES_DIR --source $__BUILDTOOLS_SOURCE /p:BuildToolsPackageVersion=$__BUILD_TOOLS_PACKAGE_VERSION /p:ToolsDir=$__TOOLRUNTIME_DIR" >> "$__init_tools_log"
166 "$__DOTNET_CMD" restore "$__INIT_TOOLS_RESTORE_PROJECT" --no-cache --packages "$__PACKAGES_DIR" --source "$__BUILDTOOLS_SOURCE" /p:BuildToolsPackageVersion=$__BUILD_TOOLS_PACKAGE_VERSION /p:ToolsDir="$__TOOLRUNTIME_DIR" >> "$__init_tools_log"
167 if [ ! -e "$__BUILD_TOOLS_PATH/init-tools.sh" ]; then
168 echo "ERROR: Could not restore build tools correctly." 1>&2
169 display_error_message
173 if [ -z "${__ILASM_RID-}" ]; then
174 __ILASM_RID=$__PKG_RID
177 echo "Using RID $__ILASM_RID for BuildTools native tools"
179 export ILASMCOMPILER_VERSION=$__ILASM_VERSION
180 export NATIVE_TOOLS_RID=$__ILASM_RID
182 if [ -n "${DotNetBootstrapCliTarPath-}" ]; then
183 # Assume ilasm is not in nuget yet when bootstrapping...
184 unset ILASMCOMPILER_VERSION
187 # Build tools only supported on x64
188 if [ "${__PKG_ARCH}" != "x64" ] && [ "${__PKG_ARCH}" != "arm" ]; then
189 echo "Skipped installing build tools."
191 echo "Initializing BuildTools..."
192 echo "Running: $__BUILD_TOOLS_PATH/init-tools.sh $__scriptpath $__DOTNET_CMD $__TOOLRUNTIME_DIR $__PACKAGES_DIR" >> "$__init_tools_log"
194 # Executables restored with .NET Core 2.0 do not have executable permission flags. https://github.com/NuGet/Home/issues/4424
195 chmod +x "$__BUILD_TOOLS_PATH/init-tools.sh"
196 "$__BUILD_TOOLS_PATH/init-tools.sh" "$__scriptpath" "$__DOTNET_CMD" "$__TOOLRUNTIME_DIR" "$__PACKAGES_DIR" >> "$__init_tools_log"
197 if [ "$?" != "0" ]; then
198 echo "ERROR: An error occurred when trying to initialize the tools." 1>&2
199 display_error_message
203 echo "Making all .sh files executable under Tools."
204 # Executables restored with .NET Core 2.0 do not have executable permission flags. https://github.com/NuGet/Home/issues/4424
205 ls "$__scriptpath/Tools/"*.sh | xargs chmod +x
206 ls "$__scriptpath/Tools/scripts/docker/"*.sh | xargs chmod +x
208 "$__scriptpath/Tools/crossgen.sh" "$__scriptpath/Tools" $__PKG_RID
210 mkdir -p "$(dirname "$__BUILD_TOOLS_SEMAPHORE")" && touch "$__BUILD_TOOLS_SEMAPHORE"
212 echo "Done initializing tools."